<template>
  <v-navigation-drawer
    v-if="['Home','Profile','Management','Settings', 'Create', 'Read', 'Notifications', 'Transcript', 'Subject', 'SubjectList'].includes($route.name)"
    id="app-drawer"
    v-model="inputValue"
    app
    dark
    floating
    persistent
    mobile-break-point="991"
    width="260"
  >
    <v-dialog
      v-model="dialog"
      max-width="290"
      persistent
    >
      <v-card>
        <v-card-text class="headline font-weight-bold text-xs-center">
          <v-form @submit.prevent="submitPin()">
            <v-text-field
              v-model="pin"
              :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
              :rules="[rules.required, rules.min, rules.validateNumber]"
              :type="show ? 'text' : 'password'"
              name="pin"
              label="PIN"
              hint="Only 6 characters"
              counter="6"
              @click:append="show = !show"
            ></v-text-field>
          </v-form>
          <span
            v-if="pinError"
            class="red--text body-2">Incorrect PIN</span>
        </v-card-text>

        <v-card-actions>
          <v-spacer/>
          <v-btn
            color="success"
            flat="flat"
            @click="submitPin()"
          >
            SUBMIT
          </v-btn>
          <v-btn
            color="error"
            flat="flat"
            @click="dialog = false; pinError=null"
          >
            CLOSE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-img

      :src="image"
      height="100%">
      <v-layout
        class="fill-height"
        tag="v-list"
        column>
        <v-list-tile avatar>
          <v-list-tile-avatar color="white">
            <v-img
              :src="logo"
              contain/>
          </v-list-tile-avatar>
          <v-list-tile-title class="title">{{ appName }}</v-list-tile-title>
        </v-list-tile>
        <v-divider/>
        <v-list-tile
          :to="{path: '/home'}"
          :active-class="color">
          <v-list-tile-action>
            <v-icon>mdi-home</v-icon>
          </v-list-tile-action>
          <v-list-tile-title>Home</v-list-tile-title>
        </v-list-tile>
        <v-list-group v-show="isAdmin">
          <v-list-tile slot="activator">
            <v-list-tile-action>
              <v-icon/>
            </v-list-tile-action>
            <v-list-tile-title>Teacher</v-list-tile-title>
          </v-list-tile>
          <v-list-tile
            :to="{path: '/create'}"
            :active-class="color">
            <v-list-tile-action>
              <v-icon/>
            </v-list-tile-action>
            <v-list-tile-title>Create</v-list-tile-title>
            <v-list-tile-action>
              <v-icon>mdi-plus</v-icon>
            </v-list-tile-action>
          </v-list-tile>
          <v-list-tile
            :active-class="color"
            @click="dialog = true">
            <v-list-tile-action>
              <v-icon/>
            </v-list-tile-action>
            <v-list-tile-title>Subject</v-list-tile-title>
            <v-list-tile-action>
              <v-icon>mdi-file-document</v-icon>
            </v-list-tile-action>
          </v-list-tile>
        </v-list-group>
        <v-list-group v-show="!isAdmin">
          <v-list-tile slot="activator">
            <v-list-tile-action>
              <v-icon/>
            </v-list-tile-action>
            <v-list-tile-title>Student</v-list-tile-title>
          </v-list-tile>
          <v-list-tile
            :active-class="color"
            @click="dialog = true">
            <v-list-tile-action>
              <v-icon/>
            </v-list-tile-action>
            <v-list-tile-title>Transcript</v-list-tile-title>
            <v-list-tile-action>
              <v-icon>mdi-file-document</v-icon>
            </v-list-tile-action>
          </v-list-tile>
        </v-list-group>
        <v-list-tile
          :active-class="color"
          @click="signOut()">
          <v-list-tile-action>
            <v-icon>mdi-logout</v-icon>
          </v-list-tile-action>
          <v-list-tile-title>Logout</v-list-tile-title>
        </v-list-tile>
      </v-layout>
    </v-img>
  </v-navigation-drawer>
</template>

<script>
// Utilities
import { mapMutations, mapState, mapGetters } from 'vuex'

export default {
  data: () => ({
    appName: 'Grading System',
    logo: '/img/logo.png',
    isAdmin: false,
    dialog: false,
    show: false,
    pin: '',
    pinError: null,
    rules: {
      required: value => !!value || 'Required.',
      min: v => v.length >= 6 || '6 characters',
      validateNumber: v => !isNaN(Number(v)) || 'The PIN you entered must be number'
    },
    responsive: false
  }),
  computed: {
    ...mapState('app', ['image', 'color']),
    ...mapGetters('web3', ['instance']),
    inputValue: {
      get () {
        return this.$store.state.app.drawer
      },
      set (val) {
        this.setDrawer(val)
      }
    },
    items () {
      return this.$t('Layout.View.items')
    }
  },
  mounted () {
    this.onResponsiveInverted()
    window.addEventListener('resize', this.onResponsiveInverted)
  },
  updated () {
    this.isAdmin = localStorage.getItem('isAdmin')
  },
  beforeDestroy () {
    window.removeEventListener('resize', this.onResponsiveInverted)
  },
  methods: {
    ...mapMutations('web3', ['clearUserProfile', 'clearAlreadyAccount']),
    ...mapMutations('app', ['setDrawer', 'toggleDrawer']),
    onResponsiveInverted () {
      if (window.innerWidth < 991) {
        this.responsive = true
      } else {
        this.responsive = false
      }
    },
    signOut: function () {
      this.$gAuth.signOut()
        .then(() => {
          this.isSignIn = this.$gAuth.isAuthorized
          localStorage.removeItem('isAuthorized')
          localStorage.removeItem('isAdmin')
          localStorage.removeItem('studentCode')
          localStorage.removeItem('lecturer')
          localStorage.removeItem('email')
          localStorage.removeItem('name')
          localStorage.removeItem('address')
          this.clearUserProfile()
          this.clearAlreadyAccount()
          this.$router.push('Login')
        })
        .catch(err => {
          console.log(err)
        })
    },
    submitPin () {
      this.dialog = true
      if (this.pin !== '') {
        this.$store.dispatch('web3/walletLoad', this.pin)
          .then((wallet) => {
            this.dialog = false
            if (localStorage.getItem('isAdmin')) {
              this.pin = ''
              this.$router.push('subject')
            } else {
              this.pin = ''
              this.$router.push('transcript')
            }
            // setTimeout(() => this.submitFiles(), 300)
          })
          .catch((error) => {
            console.log(error)
            this.pinError = error
            this.pin = ''
          })
      }
    }
  }
}
</script>

<style lang="scss">
#app-drawer {
  .v-list__tile {
    border-radius: 4px;
    }
  }

  // .v-image__image--contain {
  //   //top: 9px;
  //   //height: 60%;
  // }

  .search-input {
    margin-bottom: 30px !important;
    padding-left: 15px;
    padding-right: 15px;
  }
</style>
